put_bucket_lifecycle_configuration¶
Operation¶
put_bucket_lifecycle_configuration
async
¶
put_bucket_lifecycle_configuration(request: PutBucketLifecycleConfigurationInput | PutBucketLifecycleConfigurationInputDict, /, *, plugins: list[Plugin] | None = None) -> PutBucketLifecycleConfigurationOutput
put_bucket_lifecycle_configuration(*, plugins: list[Plugin] | None = None, **kwargs: Unpack[PutBucketLifecycleConfigurationInputDict]) -> PutBucketLifecycleConfigurationOutput
Creates a new lifecycle configuration for the bucket or replaces an existing lifecycle configuration. Keep in mind that this will overwrite an existing lifecycle configuration, so if you want to retain any configuration details, they must be included in the new lifecycle configuration. For information about lifecycle configuration, see Managing your storage lifecycle.
Note
Bucket lifecycle configuration now supports specifying a lifecycle rule using an object key name prefix, one or more object tags, object size, or any combination of these. Accordingly, this section describes the latest API. The previous version of the API supported filtering based only on an object key name prefix, which is supported for backward compatibility. For the related API description, see PutBucketLifecycle.
- Rules
-
You specify the lifecycle configuration in your request body. The lifecycle configuration is specified as XML consisting of one or more rules. An Amazon S3 Lifecycle configuration can have up to 1,000 rules. This limit is not adjustable.
Bucket lifecycle configuration supports specifying a lifecycle rule using an object key name prefix, one or more object tags, object size, or any combination of these. Accordingly, this section describes the latest API. The previous version of the API supported filtering based only on an object key name prefix, which is supported for backward compatibility for general purpose buckets. For the related API description, see PutBucketLifecycle.
Note: Lifecyle configurations for directory buckets only support expiring objects and cancelling multipart uploads. Expiring of versioned objects,transitions and tag filters are not supported. A lifecycle rule consists of the following:
-
A filter identifying a subset of objects to which the rule applies. The filter can be based on a key name prefix, object tags, object size, or any combination of these.
-
A status indicating whether the rule is in effect.
-
One or more lifecycle transition and expiration actions that you want Amazon S3 to perform on the objects identified by the filter. If the state of your bucket is versioning-enabled or versioning-suspended, you can have many versions of the same object (one current version and zero or more noncurrent versions). Amazon S3 provides predefined actions that you can specify for current and noncurrent object versions.
For more information, see Object Lifecycle Management and Lifecycle Configuration Elements.
-
- Permissions
-
- General purpose bucket permissions - By default, all Amazon S3
resources are private, including buckets, objects, and related
subresources (for example, lifecycle configuration and website
configuration). Only the resource owner (that is, the Amazon Web
Services account that created it) can access the resource. The
resource owner can optionally grant access permissions to others
by writing an access policy. For this operation, a user must have
the
s3:PutLifecycleConfigurationpermission.
You can also explicitly deny permissions. An explicit deny also supersedes any other permissions. If you want to block users or accounts from removing or deleting objects from your bucket, you must deny them permissions for the following actions:
-
s3:DeleteObject -
s3:DeleteObjectVersion -
s3:PutLifecycleConfigurationFor more information about permissions, see Managing Access Permissions to Your Amazon S3 Resources.
-
Directory bucket permissions - You must have the
s3express:PutLifecycleConfigurationpermission in an IAM identity-based policy to use this operation. Cross-account access to this API operation isn't supported. The resource owner can optionally grant access permissions to others by creating a role or user for them as long as they are within the same account as the owner and resource.
For more information about directory bucket policies and permissions, see Authorizing Regional endpoint APIs with IAM in the Amazon S3 User Guide.
Note: Directory buckets - For directory buckets, you must make requests for this API operation to the Regional endpoint. These endpoints support path-style requests in the format
https://s3express-control.region-code.amazonaws.com/bucket-name. Virtual-hosted-style requests aren't supported. For more information about endpoints in Availability Zones, see Regional and Zonal endpoints for directory buckets in Availability Zones in the Amazon S3 User Guide. For more information about endpoints in Local Zones, see Concepts for directory buckets in Local Zones in the Amazon S3 User Guide. - General purpose bucket permissions - By default, all Amazon S3
resources are private, including buckets, objects, and related
subresources (for example, lifecycle configuration and website
configuration). Only the resource owner (that is, the Amazon Web
Services account that created it) can access the resource. The
resource owner can optionally grant access permissions to others
by writing an access policy. For this operation, a user must have
the
- HTTP Host header syntax
-
Directory buckets - The HTTP Host header syntax is
s3express-control.region.amazonaws.com.The following operations are related to
PutBucketLifecycleConfiguration:
Warning
You must URL encode any signed header values that contain spaces. For
example, if your header value is my file.txt, containing two spaces
after my, you must URL encode this value to my%20%20file.txt.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
plugins
|
list[Plugin] | None
|
A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations. |
None
|
Returns:
| Type | Description |
|---|---|
PutBucketLifecycleConfigurationOutput
|
An instance of |
Input¶
Pass the input fields as keyword arguments, or pass a model or dictionary as the first positional argument. Pass plugins separately as a keyword argument.
Model¶
PutBucketLifecycleConfigurationInput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketLifecycleConfigurationInput structure.
Attributes¶
bucket
class-attribute
instance-attribute
¶
bucket: str | None = ...
The name of the bucket for which to set the configuration.
checksum_algorithm
class-attribute
instance-attribute
¶
checksum_algorithm: str | None = ...
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum or x-amz-trailer header
sent. Otherwise, Amazon S3 fails the request with the HTTP status code
400 Bad Request. For more information, see Checking object
integrity
in the Amazon S3 User Guide.
If you provide an individual checksum, Amazon S3 ignores any provided
ChecksumAlgorithm parameter.
expected_bucket_owner
class-attribute
instance-attribute
¶
expected_bucket_owner: str | None = ...
The account ID of the expected bucket owner. If the account ID that you
provide does not match the actual owner of the bucket, the request fails
with the HTTP status code 403 Forbidden (access denied).
Note
This parameter applies to general purpose buckets only. It is not supported for directory bucket lifecycle configurations.
lifecycle_configuration
class-attribute
instance-attribute
¶
lifecycle_configuration: BucketLifecycleConfiguration | None = ...
Container for lifecycle rules. You can add as many as 1,000 rules.
transition_default_minimum_object_size
class-attribute
instance-attribute
¶
transition_default_minimum_object_size: str | None = ...
Indicates which default minimum object size behavior is applied to the lifecycle configuration.
Note
This parameter applies to general purpose buckets only. It is not supported for directory bucket lifecycle configurations.
-
all_storage_classes_128K- Objects smaller than 128 KB will not transition to any storage class by default. -
varies_by_storage_class- Objects smaller than 128 KB will transition to Glacier Flexible Retrieval or Glacier Deep Archive storage classes. By default, all other storage classes will prevent transitions smaller than 128 KB.
To customize the minimum object size for any transition you can add a
filter that specifies a custom ObjectSizeGreaterThan or
ObjectSizeLessThan in the body of your transition rule. Custom filters
always take precedence over the default transition behavior.
Dictionaries¶
PutBucketLifecycleConfigurationInputDict
¶
Bases: TypedDict
Dictionary form of PutBucketLifecycleConfigurationInput.
Attributes¶
bucket
instance-attribute
¶
The name of the bucket for which to set the configuration.
checksum_algorithm
instance-attribute
¶
checksum_algorithm: str | None
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum or x-amz-trailer header
sent. Otherwise, Amazon S3 fails the request with the HTTP status code
400 Bad Request. For more information, see Checking object
integrity
in the Amazon S3 User Guide.
If you provide an individual checksum, Amazon S3 ignores any provided
ChecksumAlgorithm parameter.
expected_bucket_owner
instance-attribute
¶
expected_bucket_owner: str | None
The account ID of the expected bucket owner. If the account ID that you
provide does not match the actual owner of the bucket, the request fails
with the HTTP status code 403 Forbidden (access denied).
Note
This parameter applies to general purpose buckets only. It is not supported for directory bucket lifecycle configurations.
lifecycle_configuration
instance-attribute
¶
lifecycle_configuration: BucketLifecycleConfiguration | BucketLifecycleConfigurationDict | None
Container for lifecycle rules. You can add as many as 1,000 rules.
transition_default_minimum_object_size
instance-attribute
¶
transition_default_minimum_object_size: str | None
Indicates which default minimum object size behavior is applied to the lifecycle configuration.
Note
This parameter applies to general purpose buckets only. It is not supported for directory bucket lifecycle configurations.
-
all_storage_classes_128K- Objects smaller than 128 KB will not transition to any storage class by default. -
varies_by_storage_class- Objects smaller than 128 KB will transition to Glacier Flexible Retrieval or Glacier Deep Archive storage classes. By default, all other storage classes will prevent transitions smaller than 128 KB.
To customize the minimum object size for any transition you can add a
filter that specifies a custom ObjectSizeGreaterThan or
ObjectSizeLessThan in the body of your transition rule. Custom filters
always take precedence over the default transition behavior.
Output¶
PutBucketLifecycleConfigurationOutput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketLifecycleConfigurationOutput structure.
Attributes¶
response_metadata
class-attribute
instance-attribute
¶
Metadata about the response that produced this output. Use this to recover the request identifiers a service's support team needs in order to investigate a call. Members of the metadata are individually optional.
transition_default_minimum_object_size
class-attribute
instance-attribute
¶
transition_default_minimum_object_size: str | None = ...
Indicates which default minimum object size behavior is applied to the lifecycle configuration.
Note
This parameter applies to general purpose buckets only. It is not supported for directory bucket lifecycle configurations.
-
all_storage_classes_128K- Objects smaller than 128 KB will not transition to any storage class by default. -
varies_by_storage_class- Objects smaller than 128 KB will transition to Glacier Flexible Retrieval or Glacier Deep Archive storage classes. By default, all other storage classes will prevent transitions smaller than 128 KB.
To customize the minimum object size for any transition you can add a
filter that specifies a custom ObjectSizeGreaterThan or
ObjectSizeLessThan in the body of your transition rule. Custom filters
always take precedence over the default transition behavior.